package com.ruoyi.mall.mapper;

import java.util.List;
import java.util.Map;

import com.ruoyi.mall.domain.MallCombineGoods;
import org.apache.ibatis.annotations.Param;

/**
 * 拼团商品Mapper接口
 *
 * @author ruoyi
 * @date 2024-03-21
 */
public interface MallCombineGoodsMapper
{
    /**
     * 查询拼团商品
     *
     * @param combineId 拼团商品主键
     * @return 拼团商品
     */
    public MallCombineGoods selectMallCombineGoodsByCombineId(Long combineId);

    /**
     * 查询拼团商品列表
     *
     * @param mallCombineGoods 拼团商品
     * @return 拼团商品集合
     */
    public List<MallCombineGoods> selectMallCombineGoodsList(MallCombineGoods mallCombineGoods);

    /**
     * 新增拼团商品
     *
     * @param mallCombineGoods 拼团商品
     * @return 结果
     */
    public int insertMallCombineGoods(MallCombineGoods mallCombineGoods);

    /**
     * 修改拼团商品
     *
     * @param mallCombineGoods 拼团商品
     * @return 结果
     */
    public int updateMallCombineGoods(MallCombineGoods mallCombineGoods);

    /**
     * 删除拼团商品
     *
     * @param combineId 拼团商品主键
     * @return 结果
     */
    public int deleteMallCombineGoodsByCombineId(Long combineId);

    /**
     * 批量删除拼团商品
     *
     * @param combineIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteMallCombineGoodsByCombineIds(Long[] combineIds);

    /**
     * 拼团商品可选商品列表
     *
     * @return 拼团商品
     */
    public List<Map<String,Object>> enableCombineGoodsList();

    /**
     * 查询拼团商品
     *
     * @param goodsId 拼团商品id
     * @return 拼团商品
     */
    public int selectMallCombineGoodsByGoodsId(@Param("goodsId") Long goodsId);

    /**
     * 拼团商品列表
     *
     * @return 拼团商品
     */
    public List<Map<String,Object>> getCombineGoodsList(Map<String,Object> params);

    /**
     * 根据商品ID查询拼团商品
     *
     * @param goodsId 拼团商品id
     * @return 拼团商品
     */
    public MallCombineGoods selectCombineGoodsByGoodsId(@Param("goodsId") Long goodsId);

    /**
     * 拼团信息修改
     * @param goodsId 商品id
     * @param type 类型（0-减少库存，1-增加销量）
     * @return
     */
    public int editCombineGoodsInfo(@Param("goodsId") Long goodsId,@Param("type") Integer type,@Param("count") Integer count);
}
